//备份
function cfgbackup_export() {
  cfgbackupLoadingShow();
  jQuery.ajax({
    url: '/wmi/index.php',
    type: 'POST',
    data: JSON.encode({
      cmd: 'cfgbackup_export',
      token: UToken,
      params: {
        savedir: jQuery('#jv-selpath').val()
      }
    }),
    dataType: 'json',
    contentType: 'application/json',
    success: function(res) {
      if (res.err == 0) {

      } else {
        alertWindowFn({
          data: {
            msg: res.errmsg
          }
        });
      }
    },
    error: function(xhr, status, error) {},
    complete: function(xhr, status) {
      cfgbackupLoadingHide();
    }
  });
}

//恢复
function cfgbackup_import() {
  var filepath = jQuery('#jv-selbackupfile').val();
  cfgbackupLoadingShow();
  jQuery.ajax({
    url: '/wmi/index.php',
    type: 'POST',
    data: JSON.encode({
      cmd: 'cfgbackup_import',
      token: UToken,
      params: {
        filepath: filepath
      }
    }),
    dataType: 'json',
    contentType: 'application/json',
    success: function(res) {
      if (res.err == 0) {
        alertWindowFn({
          closable: false,
          data: {
            msg: UNAS._('备份文件恢复成功，请重启系统。'),
            closebtn: false
          }
        }, function() {
          restoreBackuppowerReboot();
        })
      } else {
        alertWindowFn({
          data: {
            msg: res.errmsg
          }
        });
      }
    },
    error: function(xhr, status, error) {},
    complete: function(xhr, status) {
      cfgbackupLoadingHide();
    }
  });
}
//
function selbackuppathchange() {
  var e = window.event || arguments.callee.caller.arguments[0];
  var dir = jQuery(e.target).val();
  cfg_folder_loadby(dir);
}

//所有文件
function cfg_folder_loadby(dir) {
  jQuery.ajax({
    url: '/wmi/index.php',
    type: 'POST',
    data: JSON.encode({
      cmd: 'folder_loadby',
      token: UToken,
      params: {
        dir: dir,
        files: 1,
      }
    }),
    dataType: 'json',
    contentType: 'application/json',
    success: function(res) {
      if (res.err == 0) {
        var records = res.results.records || [];
        var files = [];
        for (var i = 0; i < records.length; i++) {
          var t = records[i];
          if (t.foldername.indexOf('cfgbackup') > 0) {
            files.push(t.path);
          }
        }
        var h = "";
        jQuery('#jv-selbackupfile').empty();
        if (files.length) {
          for (var j = 0; j < files.length; j++) {
            h += '<option value="' + files[j] + '">' + files[j] + '</option>';
          }
          jQuery('#jv-import-apply').attr('disabled', false).attr('class', 'unas_button');
        } else {
          jQuery('#jv-import-apply').attr('disabled', true).attr('class', 'unas_button_disabled');
        }
        jQuery('#jv-selbackupfile').html(h);
      }
    },
    error: function(xhr, status, error) {},
    complete: function(xhr, status) {}
  });
}

//文件夹列表
function cfg_folder_alload() {
  jQuery.ajax({
    url: '/wmi/index.php',
    type: 'POST',
    data: JSON.encode({
      cmd: 'folder_alload',
      token: UToken
    }),
    dataType: 'json',
    contentType: 'application/json',
    success: function(data) {
      jQuery('#jv-selpath').html('');
      jQuery('#jv-selbackuppath').html('');
      if (data.err == 0) {
        var info = data.results || {};
        var folders = info.records || [];
        var str = '';
        var _len = folders.length;
        if (_len > 0) {
          for (var i = 0; i < _len; i++) {
            var f = folders[i];
            str += '<option value="' + f.path + '">' + f.path + '</option>';
          }
          cfg_folder_loadby(folders[0].path);
        } else {
          jQuery('#jv-export-apply').attr('disabled', true).attr('class', 'unas_button_disabled');
        }
        jQuery('#jv-selpath').append(str);
        jQuery('#jv-selbackuppath').append(str);
      }
    },
    error: function(xhr, status, error) {},
    complete: function(xhr, status) {}
  });
}

function restoreBackuppowerReboot() {
  jQuery.ajax({
    url: '/wmi/index.php',
    type: "POST",
    async: true,
    data: JSON.stringify({
      "cmd": "power_reboot",
      "token": UToken
    }),
    dataType: 'json',
    contentType: "application/json;charset=utf-8",
    timeout: 60000,
    success: function(r) {
      if (r.err == 0) {
        window.location.href = "/desktop/logout.php?action=logout";
      } else if (r.err == 9988) {
        alert(UNAS._("You are not administrator and have no permission to restart U-NAS."));
      }
    },
    error: function(XMLHttpRequest, textStatus, errorThrown) {

    }
  });
}

(function() {

  jQuery('#jv-cfgbackuppage div[tabtype]').each(function(i, e) {
    e.onclick = function() {
      jQuery(this).attr('class', 'unas_tab_sel')
        .siblings('div[tabtype]').attr('class', 'unas_tab');
      jQuery(this).siblings('div[tabtype]').each(function(k, ce) {
        jQuery('#jv-' + jQuery(ce).attr('tabtype')).attr('style', 'display:none;');
      })
      var id = jQuery(this).attr('tabtype');
      jQuery('#jv-' + id).attr('style', 'display:block');

      if (id == 'restore') {
        cfg_folder_alload();
      }
    }
  })

  cfg_folder_alload();
})();
